% C  PROCEDURE CALCULATES ELASTIC COEFFICIENTS OF STIFFNESS MATRIX
% C  OF TWO-NODE BEAM ELEMENT
% C     L.........LENGTH OF BEAM AXIS
% C     IN2, IN3..MOMENTS OF INERTIA, BENDING ABOUT THE X2-AXIS (IN2)
% C               OR X3-AXIS (IN3)
% C     IT... moment of inertia for torsion (about the local X1 axis)
% Output
% C     SM ... local stiffness matrix, 12 x 12
function SM = local_stiffness(self, EY, G, CSA, IN2, IN3, J, L)
    aN = local_cartesian_to_natural (self, L);
    DN= diag([EY*CSA/L,
        EY*IN3/L,
        3*EY*IN3/L,
        EY*IN2/L,
        3*EY*IN2/L,
        G*J/L]);
    SM=aN'*DN*aN;
end
