% Constructor of the finite element node set class.
%
% function self = fenodeset (varargin)
%
% Class representing finite element node set, in one dimension,
% two dimensions, or three dimensions.
% 
% See discussion of constructors in <a href="matlab:helpwin 'FAESOR/classes/Contents'">classes/Contents</a>. 
% Parameters:
% id = identifier of the node, 1<=id<=size(xyz,1)
% xyz= coordinates as a one-dimensional,
%       two-dimensional, or three-dimensional array.
%
function self = fenodeset (varargin)
    class_name='fenodeset';
    parent = classbase;
    if (nargin == 0)
        self.id = [];
        self.xyz = [];
        self = class(self,class_name,parent);
        return;
    elseif (nargin == 1)
        arg = varargin{1};
        if strcmp(class(arg),class_name) % copy constructor.
            self = arg;
            return;
        else
            Parameters = varargin{1};
            self.id = Parameters.id;
            self.xyz = Parameters.xyz;
            self = class(self,class_name,parent);
            return;
        end
    else
        error('Illegal arguments!');
    end
    return;
end


