% Evaluate the curve Jacobian.
%
% function detJ = Jacobian_curve(self, pc, x)
%
%   where
%      self=gcellset,
%      conn=connectivity of a single cell in which the Jacobian is to be evaluated
%      N=values of the basis functions, size(N) = [nbfuns,1]
%      J = Jacobian matrix
%      x=array of spatial coordinates of the nodes, size(x) = [nbfuns,dim]
%
function Jac = Jacobian_curve(self, conn, N, J, x)
    [sdim, ntan] = size(J);
    if     ntan==1 % 1-D gcell
        Jac = norm(J);
    else
        error('Got an incorrect size of tangents');
    end
end
