% Get property from the specified object and return the value.
%
% function val = get(self,varargin)
%
% See discussion of the get/set methods in <a href="matlab:helpwin
% 'FAESOR/classes/Contents'">classes/Contents</a>. 
%
function val = get(self,varargin)
    if (nargin == 1)
        val = {{{'bdryconn'}, {'connectivity (node identifiers), array [6,16]'}};
            {{'bdrygcell'}, {'constructor of the boundary gcell, function handle'}}
            };
        val = cat(1, get(self.gcell_3_manifold), val);
        return;
    else
        prop_name=varargin{1};
        switch prop_name
            case {'faceconn','bdryconn'}
                conn=get(self.gcellset_3_manifold,'conn');
                val=[conn(:,[1,5,9,13,2,6,10,14,3,7,11,15,4,8,12,16]);
                    conn(:,[4,8,12,16,20,24,28,32,36,40,44,48,52,56,60,64]);
                    conn(:,[16,15,14,13,32,31,30,29,48,47,46,45,64,63,62,61]);
                    conn(:,[13,9,5,1,29,25,21,17,45,41,37,33,61,57,53,49]);
                    conn(:,[64,63,62,61,60,59,58,57,56,55,54,53,52,51,50,49]);
                    conn(:,[1,2,3,4,17,18,19,20,33,34,35,36,49,50,51,52])];
            case {'bdrygcell'}
                val = @gcellset_Q16;
            otherwise
                val = get(self.gcellset_3_manifold, prop_name);
        end
    end

