% Draw a graphic representation.
%
% function draw (self, gv, context)
%
%
% Input arguments
% self = self
% gv = graphic viewer
% context = struct
% with mandatory fields
%    x=reference geometry field
%    u=displacement field
% with optional fields
%    facecolor = color of the faces, solid
%    colorfield =field with vertex colors
%       only one of the facecolor and colorfield may be supplied
%    shrink = shrink factor
%
function draw (self, gv, context)
    context.faces=[1,5,9;9,8,1;2,6,9;9,5,2;3,7,9;9,6,3;4,8,9;9,7,4];
    context.edges= [1,5,2,6,3,7,4,8,1];
    node_pc=[-1,-1;1,-1;1,1;-1,1;0,-1;1,0;0,1;-1,0;0,0];
    if isfield(context,'shrink')
        c=ones(size(node_pc,1),1)*(sum(node_pc)/size(node_pc,1));
        pc=c+context.shrink*(node_pc-c);
        for j=1:size(pc,1)
            context.shrunk_pc_N{j}=bfun(self,pc(j,:));
        end
    end
    draw (self.gcellset_2_manifold, gv, context);
end
