% Get property from the specified object and return the value.
%
% function val = get(self,varargin)
%
% See discussion of the get/set methods in <a href="matlab:helpwin
% 'FAESOR/classes/Contents'">classes/Contents</a>. 
%
function val = get(self,varargin)
    if (nargin == 1)
        val = {{{'thermal_conductivity'}, {'conductivity matrix, [d,d], where d=1, 2, or 3'}};...
            {{'specific_heat'}, {'specific heat, scalar'}};...
            {{'heat_source'}, {'heat source, either scalar or function handle'}}};
        val = cat(1, val, get(self.property));
        return;
    else
        prop_name=varargin{1};
        switch prop_name
            case 'thermal_conductivity'
                val = self.thermal_conductivity;
             case 'conductivity'
                val = self.thermal_conductivity;
            case 'specific_heat'
                val = self.specific_heat;
            case 'heat_source'
                val = self.heat_source;
            case 'source'
                val = self.heat_source;
            otherwise
                val = get(self.property, prop_name);
        end
    end
end
