% Implicit Austin, Krishnaprasad, Wang mid-point integrator constructor.
%   Call as:
%     ri = rotint_akw_mid
%
function retobj = rotint_akw_mid (varargin)
    class_name='rotint_akw_mid';
    parent=rotint;
    if (nargin == 0)
        self.I = eye(3,3);
        self.R = [];
        self.Omega = [];
        retobj = class(self,class_name,parent);
        return;
    elseif (nargin == 1) % cloning
        arg = varargin{1};
        if strcmp(class(arg),class_name) % copy constructor.
            retobj = arg;
        else
            self.I = eye(3,3);
            self.R = [];
            self.Omega = [];
            retobj = class(self,class_name,parent);
        end
        return;
    else
        error('Illegal arguments!');
    end
    return;
end