% Trapezoidal rule with momentum conservation
% integrator constructor. Described as TRAPM  in the paper on
% dynamically equivalent implicit integrators. Dynamically equivalent to the
% implicit midpoint Lie integrator.
%   Call as:
%     ri = rotint_dyneq_trapm
%
function retobj = rotint_dyneq_trapm (varargin)
    class_name='rotint_dyneq_trapm';
    parent=rotint;
    if (nargin == 0)
        self.I = eye(3,3);
        self.R = [];
        self.Omega = [];
        retobj = class(self,class_name,parent);
        return;
    elseif (nargin == 1) % cloning
        arg = varargin{1};
        if strcmp(class(arg),class_name) % copy constructor.
            retobj = arg;
        else
            self.I = eye(3,3);
            self.R = [];
            self.Omega = [];
            retobj = class(self,class_name,parent);
        end
        return;
    else
        error('Illegal arguments!');
    end
    return;
end

