function uniax_fiber_rod
    E1=0.4; E2=0.04; nu12=0.29; nu23=0.499999; G12=0.001;
    % graphite polymer composite
%     E1=155000;
%     E2=12100;
%     G12=4400;
%     nu12=0.248;
%     nu23=0.458;
    rho=5e-9;
    R= 2.5;
    t= 20.0;
    twist_angle= 30/360*2*pi;
    loadv=[-1,0,0]';
    conv_energy=2989;
    %         0.001199875227112 T10
    graphics = ~false;
    scale=0.01;
    nR = [1,2,3];
    nt = [2,3];
%     nR = [2,3,4];
%     nt = [5,10];
%     nt = [1];
        nR = [2];
    nt = [3];

    %
    function [fens] = to_cyl_surf(fens,gcells)
        bdry_gcells = mesh_bdry(gcells, []);
        bcl = [gcell_select(fens, bdry_gcells, ...
            struct ('box',[0 0 -100*R 100*R -100*R 100*R],'inflate',0.00001*t)),...
            gcell_select(fens, bdry_gcells, ...
            struct ('box',[t t -100*R 100*R -100*R 100*R],'inflate',0.00001*t))];
        conns=get(bdry_gcells,'conn');
        xyz=get(fens,'xyz');
        for j=setdiff((1:length(bdry_gcells)),bcl)
            conn=conns(j,:);
            for k=1:length(conn)
                xyz(conn(k),:)=[xyz(conn(k),1),R/norm(xyz(conn(k),2:3))*xyz(conn(k),2:3)];
            end
        end
        fens=set(fens,'xyz',xyz);
    end       

    function [fens,gcells] = t4cyl(t,R, nt,nR)
        [fens,gcells] = t4cylinderdel(t,R, nt,nR);
    end
    function [fens,gcells] = t4cylT10(t,R, nt,nR)
        [fens,gcells] = t4cylinderdel(t,R, nt,nR);
        [fens,gcells] = T4_to_T10(fens,gcells);
        [fens] = to_cyl_surf(fens,gcells);
    end
    function [fens,gcells] = h8cylH8(t,R, nt,nR)
        [fens,gcells]=q4circle(R,log2(nR),1.0);
        [fens1,gcells1] = mirror_mesh(fens, gcells, [1,0], [0,0]);
        [fens,gcells1,gcells2] = merge_meshes(fens1, gcells1, fens, gcells, t/10000);
        gcells=cat(2,gcells1,gcells2);
        [fens1,gcells1] = mirror_mesh(fens, gcells, [0,1], [0,0]);
        [fens,gcells1,gcells2] = merge_meshes(fens1, gcells1, fens, gcells, t/10000);
        gcells=cat(2,gcells1,gcells2);
        [fens,gcells] = extrudeq4(fens,gcells,nt,@(xyz,k)([xyz,k*t/nt]));
        fens = transform_apply(fens,@(x,d)([x(3),x(2),-x(1)]), []);
    end
    function [fens,gcells] = uh8cylH8(t,R, nt,nR)
        [fens,gcells,groups,edge_gcells,edge_groups]=targe2_mesher({...
            ['curve 1 arc ' num2str(-R) ' 0 ' num2str(R) ' 0 Center 0 0.000001 '],...
            ['curve 2 arc ' num2str(R) ' 0 ' num2str(-R) ' 0 Center 0 -0.000001'],...
            ['subregion 1  property 1 boundary  1  2 '],...
            ['m-ctl-point constant ' num2str(1.8*R/nR)]
            }, 1.0);
        [fens,gcells] = T3_to_Q4(fens,gcells,[]);
        [fens,gcells] = extrudeq4(fens,gcells,nt,@(xyz,k)([xyz(1:2),k*t/nt]));
        fens = transform_apply(fens,@(x,d)([x(3),x(2),-x(1)]), []);
        [fens] = to_cyl_surf(fens,gcells);
    end
    function [fens,gcells] = h8cylH27(t,R, nt,nR)
        [fens,gcells] = h8cylH8(t,R, nt,nR);
        [fens,gcells] = H8_to_H27(fens,gcells);
        [fens] = to_cyl_surf(fens,gcells);
    end
    function [fens,gcells] = uh8cylH27(t,R, nt,nR)
        [fens,gcells] = uh8cylH8(t,R, nt,nR);
         [fens] = to_cyl_surf(fens,gcells);
        [fens,gcells] = H8_to_H27(fens,gcells);
        [fens] = to_cyl_surf(fens,gcells);
    end
    function [fens,gcells] = uh8cylH20(t,R, nt,nR)
        [fens,gcells] = uh8cylH8(t,R, nt,nR);
         [fens] = to_cyl_surf(fens,gcells);
        [fens,gcells] = H8_to_H20(fens,gcells);
        [fens] = to_cyl_surf(fens,gcells);
    end
    
    eix=1;
    clear eltyd
    
eltyd(eix).label ='T4';
eltyd(eix).mf =@t4cyl;
eltyd(eix).blf =@feblock_defor_ss;
eltyd(eix).integration_rule= tet_rule(1);
eltyd(eix).surface_integration_rule=tri_rule(1);
eltyd(eix).styl='rv-.';
eix=eix+1;
% 
% eltyd(eix).label ='H8';
% eltyd(eix).mf =@uh8cylH8;
% eltyd(eix).blf =@feblock_defor_ss;
% eltyd(eix).integration_rule= gauss_rule (3,2);
% eltyd(eix).surface_integration_rule=gauss_rule (2,2);
% eltyd(eix).styl='rx-.';
% eix=eix+1;
% 
eltyd(eix).label ='NICE-T4';
eltyd(eix).mf =@t4cyl;
eltyd(eix).blf =@feblock_defor_ss_nicer;
eltyd(eix).integration_rule= simplex_nq_rule (3);
eltyd(eix).surface_integration_rule=tri_rule(1);
eltyd(eix).styl='m^-';
eix=eix+1;
% 
% eltyd(eix).label ='NICE-H8';
% eltyd(eix).mf =@uh8cylH8;
% eltyd(eix).blf =@feblock_defor_ss_nicer;
% eltyd(eix).integration_rule= tensprod_nq_rule (struct('dim',3,'order',1));
% eltyd(eix).surface_integration_rule=tensprod_nq_rule (struct('dim',2,'order',1));
% eltyd(eix).styl='md-';
% eix=eix+1;

% eltyd(eix).label ='T10';
% eltyd(eix).mf =@t4cylT10;
% eltyd(eix).blf =@feblock_defor_ss;
% eltyd(eix).integration_rule=tet_rule (4);
% eltyd(eix).surface_integration_rule=tri_rule(3);
% eltyd(eix).styl='kv--';
% eix=eix+1;
% 
% eltyd(eix).label ='H27';
% eltyd(eix).mf =@uh8cylH27;
% eltyd(eix).blf =@feblock_defor_ss;
% eltyd(eix).integration_rule=gauss_rule (3,3);
% eltyd(eix).surface_integration_rule=gauss_rule(2, 2);
% eltyd(eix).styl='ks-';
% eix=eix+1;

eltyd(eix).label ='NICE-H27';
eltyd(eix).mf =@uh8cylH27;
eltyd(eix).blf =@feblock_defor_ss_nicer;
eltyd(eix).integration_rule=tensprod_nq_rule (struct('dim',3,'order',2));
eltyd(eix).surface_integration_rule=tensprod_nq_rule (struct('dim',2,'order',2));
eltyd(eix).styl='mh-';
eix=eix+1;

% eltyd(eix).label ='H20R';
% eltyd(eix).mf =@uh8cylH20;
% eltyd(eix).blf =@feblock_defor_ss;
% eltyd(eix).integration_rule=gauss_rule (3,2);
% eltyd(eix).surface_integration_rule=gauss_rule(2, 2);
% eltyd(eix).styl='ro-';
% eix=eix+1;
% % 
% 
% 
% eltyd(eix).label ='NICE-H20';
% eltyd(eix).mf =@uh8cylH20;
% eltyd(eix).blf =@feblock_defor_ss_nicer;
% eltyd(eix).integration_rule=tensprod_nq_rule (struct('dim',3,'order',2));
% eltyd(eix).surface_integration_rule=tensprod_nq_rule (struct('dim',2,'order',2));
% eltyd(eix).styl='mo--';
% eix=eix+1;
% % 
% eltyd(eix).label ='H20';
% eltyd(eix).mf =@uh8cylH20;
% eltyd(eix).blf =@feblock_defor_ss;
% eltyd(eix).integration_rule=gauss_rule (3,3);
% eltyd(eix).surface_integration_rule=gauss_rule(2, 2);
% eltyd(eix).styl='k>--';
% eix=eix+1;

    function [neqns,energy] =do_twist_t10(nR,nt)
        
        function Rm = default (XYZ, ts)
            Rm= eye(3);
        end
        function Rm = twist (XYZ, ts)
            r= norm(XYZ( 2:3));
            if r>0
                y=XYZ(2);z=XYZ(3);
                e2 = [0, y/r, z/r]';
                e3 = skewmat([1, 0, 0])*e2;
                Rm= [[1, 0, 0]',e2,e3];
                Rm=rotmat(r/R*twist_angle*skewmat(e2))*Rm;
            else
                Rm= eye(3);
            end
        end
        % Mesh
        [fens,gcells] = eltyd(eix).mf (t,R, nt,nR);
%                  mesh{1}=fens;
%                     mesh{2}=gcells;
%                     drawmesh(mesh); view(3); pause%(1)
        % Material
        prop = property_linel_transv_iso (...
            struct('E1',E1,'E2',E2,'G12',G12,'nu12',nu12,'nu23',nu23,'rho',rho));
        mater = mater_defor_ss_linel_triax (struct('property',prop));
        % Finite element block
        feb = eltyd(eix).blf (struct ('mater',mater, 'gcells',gcells,...
            'integration_rule',eltyd(eix).integration_rule,'Rm',@twist));
        % Geometry
        geom = field(struct ('name',['geom'], 'dim', 3, 'fens',fens));
        % Define the displacement field
        u   = 0*geom; % zero out
        % Apply EBC's
        nl=[fenode_select(fens, struct('box', [0,0,-R,R,-R,R],...
            'inflate',0.001))];
        u   = set_ebc(u,nl,nl*0+1, [], nl*0);
        u   = apply_ebc (u);
        % Number equations
        u   = numbereqns (u);
        disp (['%' eltyd(eix).label ': number of equations =' num2str(get(u,'neqns'))])
        % Assemble the system matrix
        K = start (sparse_chol_sysmat, get(u, 'neqns'));
        K = assemble (K, stiffness(feb, geom, u));
        fi= force_intensity(struct ('magn',loadv));
        bdry_gcells = mesh_bdry(gcells, []);
        bcl = gcell_select(fens, bdry_gcells, ...
            struct ('box',[t t -100*R 100*R -100*R 100*R],'inflate',0.00001*t));
        lfeb = feblock_defor_ss(struct ('mater',mater, 'gcells',subset(bdry_gcells,bcl),...
            'integration_rule',eltyd(eix).surface_integration_rule));
        F = start (sysvec, get(u, 'neqns'));
        F = assemble (F, distrib_loads(lfeb, geom, u, fi, 2));

        %% Solve K*u=F
        b=get(F,'vec');%sum(b)
        x=get(K,'mat')\b;
        %     a=get(K,'mat');
        %     x = bicg(get(K,'mat'),get(F,'vec'), 1e-6, 14000, diag(diag (get(K,'mat'))));
        %     x=0*b;
        %     for it = 1:50
        %         res=b-a*x;
        %         norm (res)
        %         x= x+a\res;
        %     end
        %     [Lf,Uf]=lu(a);
        %     x=Uf\(Lf\b);

        %% Transfer the solution to the field u
        u = scatter_sysvec(u, x);
        energy=b'*x/2;
        neqns=   get(u,'neqns');
        disp (['%     Energy =' num2str(energy) ' (' num2str(100*energy/conv_energy) '%10)'])
        
        % Plot
        if graphics
            gv=graphic_viewer;
            gv=reset (gv,[]);
            % draw(feb,gv, struct ('x', geom,'u',0*u, 'facecolor','none'));
            fld = field_from_integration_points(feb, geom, u, [], 'vol_strain', 1);
            nvals=get(fld,'values');
            dcm=data_colormap(struct ('range',[min(nvals),max(nvals)], 'colormap',jet));
            colorfield=field(struct ('name', ['colorfield'], 'data',map_data(dcm, nvals)));
            draw(feb, gv, struct ('x',geom,'u', scale*u, 'colorfield',colorfield, 'shrink',1));
            %             draw(feb, gv, struct ('x',geom,'u', scale*u, 'facecolor',[0.9,0.93,0.9], 'linewidth', 3));
            %             draw(feb, gv, struct ('x',geom,'u', 0*u, 'facecolor','none','edgecolor','black', 'shrink',1));
            colormap(jet);
            cbh=colorbar;
            set(cbh,...
                'Position',[0.8 0.15 0.1 0.7],...
                'YLim',[0,1],...
                'YTick',[0,1],...
                'YTickLabel',{[num2str(min(nvals))],[num2str(max(nvals))]});%{[num2str((min(nvals)))],[num2str((max(nvals)))]}
            set(get(cbh,'XLabel'),'String','\sigma_{y}');
            title ('Stress');
            camset (gv, [  6.8466e+001 -1.5215e+002  5.8597e+001  8.8141e+000 -7.1835e-001 -6.4214e-001            0 0  1.0000e+000  4.5469e+000]);
            %                             8.9671  13.8115   -3.4482
                end
    end


    for eix = 1:length(eltyd)
        neqnss=[];
        energys=[];
        for i=1:length(nR)
            for j=1:length(nt)
                [neqns,energy]= do_twist_t10(nR(i),nt(j));
                neqnss=[neqnss,neqns];
                energys=[energys,energy];
            end
        end
        disp(['Data{end+1}=[']);
        disp([neqnss;energys]);
        disp(['];' 'Style{end+1}=''' eltyd(eix).styl ''';' 'Legends{end+1} =''' eltyd(eix).label ''';']);
    end
end