function sphere_inertia(Radius,nsubdivisions)
    if (~ exist ('Radius') )
        Radius=3;
    end
    if (~ exist ('nsubdivisions') )
        nsubdivisions=2;
    end
    R=Radius;
    tol=R/nsubdivisions/2/1000;
    [fens,gcells]=H8_sphere(R,nsubdivisions);
    [fens1,gcells1] = mirror_mesh(fens, gcells, [-1,0,0], [0,0,0], @(c)c([1, 4, 3, 2, 5, 8, 7, 6]));
    [fens,gcells1,gcells2] = merge_meshes(fens1, gcells1, fens, gcells, tol);
    gcells=cat(gcells1,gcells2);
    [fens1,gcells1] = mirror_mesh(fens, gcells, [0,-1,0], [0,0,0], @(c)c([1, 4, 3, 2, 5, 8, 7, 6]));
    [fens,gcells1,gcells2] = merge_meshes(fens1, gcells1, fens, gcells, tol);
    gcells=cat(gcells1,gcells2);
    [fens1,gcells1] = mirror_mesh(fens, gcells, [0,0,-1], [0,0,0], @(c)c([1, 4, 3, 2, 5, 8, 7, 6]));
    [fens,gcells1,gcells2] = merge_meshes(fens1, gcells1, fens, gcells, tol);
    gcells=cat(gcells1,gcells2);
    CG1= 10*[1,-2,3];
    fens = transform_apply(fens,@(x,d)x+CG1, []);
    drawmesh({fens,gcells},'gcells','facecolor','red');
     
    geom = field(struct ('name',['geom'], 'dim', 3, 'fens',fens));
    feb = feblock (struct ('mater',[], 'gcells',gcells,...
        'integration_rule', gauss_rule (3,2)));
    V=measure(feb,geom,@(x)(1));
    disp( [' Volume = '  num2str(V) ' (' num2str(4/3*pi*R^3) ')'])
    S=measure(feb,geom,@(x)(x));
    CG=S/V;
    disp( [' Center of gravity = '  num2str(CG) ' (' num2str(CG1) ')'])
    I=measure(feb,geom,@(x)(norm(x-CG)^2*eye(3)-(x-CG)'*(x-CG)));
    disp( [' Tensor of inertia = ' ])
    I
    2/5*V*R^2*eye(3)
end