function [h,utip]=cookstrain
    smult=0;

    lambda = 0.75e1;
    G= 0.375;
    convutip=16.432584376299037;% NICE-T6 t3block2d with Richardson
    nu =1/2*lambda/(G+lambda)
    E=G*(3*lambda+2*G)/(G+lambda);

    
    [h,utip]=do_it(smult,E,nu, @T3_block,@feblock_defor_ss,tri_rule(1),gauss_rule(1, 1));
    %     [h,utip]=do_it(smult,E,nu, @block2d,@feblock_defor_ss,gauss_rule(2,2),gauss_rule(1, 1));
    % [h,utip]=do_it(smult,E,nu, @blok2dT6,@feblock_defor_ss,tri_rule(3),gauss_rule(1, 2));
    [xestim, beta, residual] = richextrapol( utip(end-2:end),h(end-2:end))
    %      assignin('caller','faesor_test_passed',((norm([11.992802616608039]-utip(1)))<1e-12));
end

function [h,utip]=do_it(smult,E,nu, mf,blf,ir,eir)
    disp(['Cooks problem, plane strain: ' func2str(blf)]);
    % Parameters:
    graphics=~true;
    doeig=~true;
    aspect=1;
    tol=48/10000;

    % Mesh
    h=[];
    utip=[];
    magn=1;
    for n=[2,4,8,16,32]
%     for n=[2, 4,8]
        [fens,gcells] = mf(48,44, n, aspect*n, 1.0);
        dxy=min(48,44)/n/aspect/100;
        sxy=smult*dxy;
        rand('state',[0.3085,0.4953,0.0143,0.3137,0.7750,0.8827,0.6275,0.5996,0.3557,0.8033,0.4425,0.3749,0.3086,0.6245,0.0244,0.0309,0.1962,0.2670,0.8672,0.8259,0.3590,0.6446,0.3018,0.6694,0.5783,0.3251,0.0024,0.9082,0.4464,0.0331,0.9344,0.0261,0,0.0000,0.0000]');
        xy=get (fens,'xyz');
        for i=1:count(fens)
            if (xy(i,1)>dxy) & (xy(i,2)>dxy) & (xy(i,1)<48-dxy) & (xy(i,2)<44-dxy)
                xy(i,:)=[xy(i,1)+(2*rand(1)-1)/2*sxy,xy(i,2)+(2*rand(1)-1)/2*sxy];
            end
            xy(i,:)=[xy(i,1),xy(i,2) + (xy(i,1)/48)*(44 -xy(i,2)/44*28)];
        end
        fens=set(fens,'xyz', xy);
        %             mesh{1}=fens;
%             mesh{2}=gcells;
%             drawmesh(mesh); view(2); pause (1)
        %     Material
        prop = property_linel_iso (struct('E',E,'nu',nu));
        mater = mater_defor_ss_linel_biax (struct('property',prop, ...
            'reduction','strain'));
        % Finite element block
        feb = blf(struct ('mater',mater, 'gcells',gcells, 'integration_rule',ir,'stabfact',0));
        % Geometry
        geom = field(struct ('name',['geom'], 'dim', 2, 'fens',fens));
        % Define the displacement field
        u   = clone(geom,'u');
        u   = u*0; % zero outfunction five
        % Apply EBC's
        ebc_fenids=fenode_select (fens,struct('box',[0,0,0, 44],'inflate',44/10000));
        ebc_prescribed=ones(1,length (ebc_fenids));
        ebc_comp=[];
        ebc_val=ebc_fenids*0;
        u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
        u   = apply_ebc (u);
        % Number equations
        u   = numbereqns (u);
        % Assemble the system matrix
        K = start (sparse_sysmat, get(u, 'neqns'));
        K = assemble (K, stiffness(feb, geom, u));
        % Load
        bdry_gcells = mesh_bdry(gcells, struct('other_dimension', 1.0));
        icl = gcell_select(fens, bdry_gcells, struct('box', [48,48,44,60],'inflate',tol));
        efeb = feblock_defor_ss(struct ('mater',mater,'gcells',subset(bdry_gcells,icl),...
            'integration_rule',eir));
        fi=force_intensity(struct('magn',[0;magn/(60-44)]));
        F = start (sysvec, get(u, 'neqns'));
        F = assemble (F, distrib_loads(efeb, geom, u, fi, 2));
        % Solve
        a = get(K,'mat');
        b = get(F,'vec');
        x = a\b;
        u = scatter_sysvec(u, x);
        nl=fenode_select (fens,struct ('box',[48,48,52,52],'inflate',tol));
        theutip=gather(u,nl,'values');
        disp (['displacement =' num2str(theutip(2))])
        h=[h 44/n];
        utip =[utip theutip(2)];

        % Plot
        if graphics
            gv=graphic_viewer;
            gv=reset (gv,struct ([]));
            scale=1;
            cmap = jet;
            fld = field_from_integration_points_spr(feb, geom, u, [], 'Cauchy', 1);
            nvals=get(fld,'values');%min(nvals),max(nvals)
            % nvalsrange=[-0.0001 0.0001];%[min(nvals),max(nvals)]
            nvalsrange=[min(nvals),max(nvals)];
            dcm=data_colormap(struct ('range',nvalsrange, 'colormap',cmap));
            colorfield=field(struct ('name', ['colorfield'], 'data',map_data(dcm, nvals)));
            draw(feb,gv, struct ('x', geom, 'u', +scale*u,'colorfield',colorfield, 'shrink',1.0));
            set_graphics_defaults(gcf)
            % geom3d=combine (geom, 0*fld);
            % u3d=combine (u, 100000000*fld);
            % draw(feb,gv, struct ('x', geom3d, 'u', +scale*u3d,'colorfield',colorfield, 'shrink',1.0));
            colormap(cmap);
            draw_colorbar(gv, struct('position',[0.8 0.15 0.05 0.7],...
                'minmax',[0,1],...
                'label','\sigma_x'))
%             cbh=colorbar;
%             set(cbh,...
%                 'Position',[0.8 0.15 0.05 0.7],...
%                 'YLim',[0,1],...
%                 'YTick',[0,1],...
%                 'YTickLabel',{[num2str(nvalsrange(1))],[num2str(nvalsrange(2))]});%{[num2str((min(nvals)))],[num2str((max(nvals)))]}
%             set(get(cbh,'XLabel'),'String','\sigma_x');
            view (2)
            %         for i=1:length(fens)
            %             draw(fens(i),gv, struct ('x', geom, 'u', 0*u, 'facecolor','blue'));
            %         end
            if doeig
                pause(2)
                %% Solve the eigenvibration problem
                neigvs = get(u,'neqns');
                [modes,Omega]=eig(full(a));
                [b,ix]=sort(diag(Omega));

                %% Display the first few eigenvibration modes
                mscale=1;
                w=clone(u,'w'); % make a copy of u
                for i=1:neigvs
                    disp(['  Eigenvector ' num2str(i) ' eigenvalue ' num2str(Omega(ix(i),ix(i))) ]);
                    w = scatter_sysvec(w, modes(:,ix(i)));
                    wv = get(w,'values');
                    wmag = sqrt(wv(:,1).^2+wv(:,2).^2);
                    dcm=data_colormap(struct ('range',[min(wmag),max(wmag)], 'colormap',jet));
                    colorfield = field(struct ('name',['cf'], 'dim', 3, 'data',map_data(dcm, wmag)));
                    for scale=mscale*sin((0:1:42)/21*2*pi)
                        gv=reset (clear (gv),struct ('limits', [-1/40*48 41/40*48 -1/40*60 5/4*60]));
                        %         headlight(gv);
                        draw(feb,gv, struct ('x', geom, 'u', scale*w,'colorfield',colorfield));
                        title(['  Eigenvector ' num2str(i) ' eigenvalue ' num2str(Omega(ix(i),ix(i))) ]);
                        pause(0.01);
                    end
                    title(['  Next eigenvector: type any key' ]);
                    clf;
                    pause(2); % next eigenvector
                end
            end
        end
    end
end