% INTERACTIONS BETWEEN A PARTIALLY OR TOTALLY
% IMMERSED VIBRATING CANTILEVER PLATE AND THE
% SURROUNDING FLUID
% Y. Fu AND W.G. PRICE
% Journal ofSound and Vibration (1987) 118(3), 495-513
% Table 4
% This is the case of a square cantilever plate Entirely submerged in
% water
% frequency 1, 2, 3, 4, 5 [Radians per second]
% 7.35, 20.20, 50.45, 70.41, 78.85
% Dry frequencies (Obtained with a 20 node brick)
% 12.80659      31.13771      78.21156      99.58361      113.0017
neigvs = 5;
for nw=10
    nl =round(nw*1);
rhow=1e-9;% tonne per millimeter cube
sqplflu_dry;
disp (['Boundary: ' sprintf('%d/%d/%d %d:%02d:%02.3f',clock)])
bdry_gcells = mesh_bdry(gcells, []);
rl=[gcell_select(fens,bdry_gcells,struct ('box',[-Inf Inf -Inf Inf Height Height],'inflate',0.0005)),...
gcell_select(fens,bdry_gcells,struct ('box',[-Inf Inf -Inf Inf 0 0],'inflate',0.0005))];
% Uncomment the line below To select just one of the surfaces
% rl=[gcell_select(fens,bdry_gcells,struct ('box',[-Inf Inf -Inf Inf Height Height],'inflate',0.0005))];
bdry_gcells =subset(bdry_gcells,rl);

% corners =[fenode_select(fens,struct('box',[0,0,0,0,-Inf,Inf],'inflate',0.0005)),...
%     fenode_select(fens,struct('box',[Length,Length,0,0,-Inf,Inf],'inflate',0.0005)),...
%     fenode_select(fens,struct('box',[Length,Length,Width,Width,-Inf,Inf],'inflate',0.0005)),...
%     fenode_select(fens,struct('box',[0,0,Width,Width,-Inf,Inf],'inflate',0.0005))];
% sqplflu_animation_speedy

disp (['Pressure modes: ' sprintf('%d/%d/%d %d:%02d:%02.3f',clock)])
[nrmls,areas]=nodal_normals_areas(fens,bdry_gcells);
for i=1:size(areas,1)
    if (areas(i)>0)
        M(i,i)=M(i,i) +4.05*areas(i)*sqrt(areas(i))*rhow;
%         M(i,i)=M(i,i) +4.05*areas(i)*(Length/nl)*rhow;
    end
end 
   
options.disp =0;
options.issym =1;
options.p =2*neigvs;
[W,Omega]=eigs(@(b) (K\b),get(u, 'neqns'),M,neigvs,'SM',options);

[Omegas,ix]=sort(diag(Omega));
W=W(:,ix);
Omega= diag(Omegas);

disp('Wet Natural frequencies [radians per second]')
disp(num2str(sqrt(diag(Omega)')))
disp ([' Finished: ' sprintf('%d/%d/%d %d:%02d:%02.3f',clock)])
end