% Spherical shell, first mode, geometry-based mesh
n_R= [10,15,20,25,30,35]
frequency1= [1257.61 1247.87 1245.09 1243.08 1242.10 1241.51]
frequency6= [1597.07 1555.92 1546.43 1539.54 1537.05 1534.76]

h=1./n_R(2:end)
Ea= diff(frequency1)./((frequency1(1:end-1)+frequency1(2:end))/2)
 loglog(h,abs(Ea),'ro-','Linewidth',3)
hold on
Ea= diff(frequency6)./((frequency6(1:end-1)+frequency6(2:end))/2)
loglog(h,abs(Ea),'rx-','Linewidth',3)
beta= diff(log( abs(Ea)))./ diff(log(h))

% Spherical shell, first mode, image-based mesh
n_R= [10,15,20,25,30,35]
frequency1= [1127.34 1188.76 1196.75 1207.82 1210.83 1215.56]
frequency6= [1308.99 1459.07 1464.36 1482.24 1480.86 1499.53]

h=1./n_R(2:end)
Ea= diff(frequency1)./((frequency1(1:end-1)+frequency1(2:end))/2)
loglog(h,abs(Ea),'bo-','Linewidth',3)
Ea= diff(frequency6)./((frequency6(1:end-1)+frequency6(2:end))/2)
loglog(h,abs(Ea),'bx-','Linewidth',3)
beta= diff(log( abs(Ea)))/ diff(log(h))
set(gca,'xlim', [0.01,0.1])
grid on
set_graphics_defaults
set_label_defaults
labels (' Mesh size',' Relative approximate error')


