% Create a mesh of a quarter circle 
% with a given number of elements per radius.
%
% function [fens,gcells]=Q4_circle_n(radius,nrefine,thickness)
%
% Create a mesh of 1/4 of the circle of "radius". The  mesh will consist of
% 3*(nperradius/2)^2 quadrilateral elements, which corresponds to 4*nperradius
% element edges per circumference. The parameter nperradius should be an even 
% number; if that isn't so is adjusted to by adding one. 
function [fens,gcells]=Q4_circle_n(radius,nperradius,thickness)
    [fens,gcells]=Q4_sphere_n(radius,nperradius,thickness);
    % apply transformation to project the locations of the nodes into the
    % plane x-y
    xyz=get(fens,'xyz');
    for j=1:count(fens)
        xyz(j,1:2) = xyz(j,1:2)*((radius-norm(xyz(j,3)))+norm(xyz(j,3))/2)/radius;
    end
    fens=set(fens,'xyz', xyz(:,1:2));
end
