% Convert a mesh of triangles T3 to three quadrilateral Q4's each.
%
% function [fens,gcells] = T3_to_Q4(fens,gcells,options)
%
% options =attributes recognized by the constructor gcell_Q4
function [fens,gcells] = T3_to_Q4(fens,gcells,options)
    [fens,gcells] = T3_to_T6(fens,gcells,options);
    if ~isstruct(options)
        options = struct('id',1);
    end
    onfens=count(fens);
    id1=get(fens,'id');
    xyz1=get(fens,'xyz');
    id=zeros(count(fens)+count(gcells),1);
    id(1:count(fens),1)=id1;
    xyz=zeros(count(fens)+count(gcells),3);
    xyz(1:count(fens),1:size(xyz1,2))=xyz1;
    % construct new geometry cells
    nconns=zeros(3*count(gcells),4);
    conns = get(gcells,'conn');
    nc=onfens+1;
    gc=1;
    for i= 1:count(gcells)
        conn=conns(i,:);
        id(nc)=nc;
        xyz(nc,:)=mean(xyz(conn(1:3),:));
        nconns(gc,:) =[conn(1) conn(4) nc conn(6)];
        gc=gc+1;
        nconns(gc,:) =[conn(2) conn(5) nc conn(4)];
        gc=gc+1;
        nconns(gc,:) =[conn(3) conn(6) nc conn(5)];
        gc=gc+1;
        nc= nc+ 1;
    end
    options.conn=nconns;
    gcells=gcellset_Q4(options);
    fens=  set(fens,'id',id);
    fens=  set(fens,'xyz',xyz);
end
