% Extract the node numbers of the nodes  connected by given gcells. 
%
% function cn = connected_nodes(gcells)
%
% Extract the list of unique node numbers for the nodes that 
%  are connected by the gcells. Note that it is assumed that all the
%  geometric cells are of the same type (the same number of connected nodes
%  by each cell).
% 
function cn = connected_nodes(gcells)
    conn= get(gcells,'conn');
    all_nodes = conn;
    cn = unique(reshape(all_nodes,prod(size(conn)), 1),'rows');
end
